#!/bin/bash

if [ "$1" == "dock" ];then
	
	killall Dock
	
	while [ "`ps xwww | grep -v grep | grep -c '/System/Library/CoreServices/Dock.app/Contents/MacOS/Dock'`" == "0" ]
	do
		sleep 0.5
	done
	
elif [ "$1" == "finder" ];then
	
	if [ "$2" == "reopenwindows" ];then
		# retain open windows
		TMPFILE="/tmp/org.hasseg.hiddenSettingsPrefPane.openFinderWindows"
		TMPSCRIPT="/tmp/org.hasseg.hiddenSettingsPrefPane.reopenFinderWindowsTempScript.bash"
		
		echo "#!/bin/bash
/usr/bin/osascript <<END_OSASCRIPT
tell application \"Finder\"
	set openWindows to {}
	repeat with i from 1 to count of Finder windows
		try
			set end of openWindows to quoted form of (folder of Finder window i as string)
		end try
	end repeat
return openWindows
end tell
END_OSASCRIPT" > "$TMPSCRIPT"
		chmod a+x "$TMPSCRIPT"
		"$TMPSCRIPT" > "$TMPFILE"
	fi
	
	
	killall Finder
	
	while [ "`ps xwww | grep -v grep | grep -c '/System/Library/CoreServices/Finder.app/Contents/MacOS/Finder'`" == "0" ]
	do
		sleep 0.5
	done
	
	
	if [ "$2" == "reopenwindows" ];then
		# reopen windows
		TMPFILECONTENTS="`cat \"$TMPFILE\"`"
		
		if [ "$TMPFILECONTENTS" != "" ];then
			TMPFILECONTENTS=${TMPFILECONTENTS//\'/\"}
			echo "#!/bin/bash
/usr/bin/osascript <<END_OSASCRIPT
tell application \"Finder\"
	set windowsToOpen to {$TMPFILECONTENTS}
	repeat with i in windowsToOpen
		open i
	end repeat
end tell
END_OSASCRIPT" > "$TMPSCRIPT"
			chmod a+x "$TMPSCRIPT"
			exec "$TMPSCRIPT"
		fi
		
		rm "$TMPSCRIPT"
		rm "$TMPFILE"
	fi
	
elif [ "$1" == "safari" ];then
	
	osascript -e "tell application \"Safari\" to quit"
	open -a Safari
	
elif [ "$1" == "frontrow" ];then
	
	killall "Front Row"
	
fi
